Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3726)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3727)
@@ -242,231 +335,253 @@
                surfaces%npoints     = surfaces%npoints + 1    
                point_index(k,j+1,i) = surfaces%npoints - 1
-            ENDIF           
+            ENDIF    
          ENDDO
-      ENDDO
-      DO  m = 1, surf_lsm_h%ns
-         i = surf_lsm_h%i(m) + surf_lsm_h%ioff
-         j = surf_lsm_h%j(m) + surf_lsm_h%joff
-         k = surf_lsm_h%k(m) + surf_lsm_h%koff
-
-         IF ( point_index(k,j,i) < 0 )  THEN
-            surfaces%npoints   = surfaces%npoints + 1    
-            point_index(k,j,i) = surfaces%npoints - 1
-         ENDIF
-         IF ( point_index(k,j,i+1) < 0 )  THEN
-            surfaces%npoints     = surfaces%npoints + 1    
-            point_index(k,j,i+1) = surfaces%npoints - 1
-         ENDIF
-         IF ( point_index(k,j+1,i+1) < 0 )  THEN
-            surfaces%npoints       = surfaces%npoints + 1    
-            point_index(k,j+1,i+1) = surfaces%npoints - 1
-         ENDIF
-         IF ( point_index(k,j+1,i) < 0 )  THEN
-            surfaces%npoints     = surfaces%npoints + 1    
-            point_index(k,j+1,i) = surfaces%npoints - 1
-         ENDIF    
-      ENDDO
-      DO  m = 1, surf_usm_h%ns
-         i = surf_usm_h%i(m) + surf_usm_h%ioff
-         j = surf_usm_h%j(m) + surf_usm_h%joff
-         k = surf_usm_h%k(m) + surf_usm_h%koff
-
-         IF ( point_index(k,j,i) < 0 )  THEN
-            surfaces%npoints   = surfaces%npoints + 1    
-            point_index(k,j,i) = surfaces%npoints - 1
-         ENDIF
-         IF ( point_index(k,j,i+1) < 0 )  THEN
-            surfaces%npoints     = surfaces%npoints + 1    
-            point_index(k,j,i+1) = surfaces%npoints - 1
-         ENDIF
-         IF ( point_index(k,j+1,i+1) < 0 )  THEN
-            surfaces%npoints       = surfaces%npoints + 1    
-            point_index(k,j+1,i+1) = surfaces%npoints - 1
-         ENDIF
-         IF ( point_index(k,j+1,i) < 0 )  THEN
-            surfaces%npoints     = surfaces%npoints + 1    
-            point_index(k,j+1,i) = surfaces%npoints - 1
-         ENDIF     
-      ENDDO
-!
-!--   Vertical surfaces
-      DO  l = 0, 3
-         DO  m = 1, surf_def_v(l)%ns
-!
-!--         Determine the indices of the respective grid cell inside the topography.
-!--         Please note, j-index for north-facing surfaces ( l==0 ) is 
-!--         identical to the reference j-index outside the grid box. 
-!--         Equivalent for east-facing surfaces and i-index.
-            i = surf_def_v(l)%i(m) + MERGE( surf_def_v(l)%ioff, 0, l == 3 )
-            j = surf_def_v(l)%j(m) + MERGE( surf_def_v(l)%joff, 0, l == 1 )
-            k = surf_def_v(l)%k(m) + surf_def_v(l)%koff
-!
-!--         Lower left /front vertex
+         DO  m = 1, surf_usm_h%ns
+            i = surf_usm_h%i(m) + surf_usm_h%ioff
+            j = surf_usm_h%j(m) + surf_usm_h%joff
+            k = surf_usm_h%k(m) + surf_usm_h%koff
+
             IF ( point_index(k,j,i) < 0 )  THEN
                surfaces%npoints   = surfaces%npoints + 1    
                point_index(k,j,i) = surfaces%npoints - 1
-            ENDIF 
-!
-!--         Upper / lower right index for north- and south-facing surfaces
-            IF ( l == 0  .OR.  l == 1 )  THEN
+            ENDIF
+            IF ( point_index(k,j,i+1) < 0 )  THEN
+               surfaces%npoints     = surfaces%npoints + 1    
+               point_index(k,j,i+1) = surfaces%npoints - 1
+            ENDIF
+            IF ( point_index(k,j+1,i+1) < 0 )  THEN
+               surfaces%npoints       = surfaces%npoints + 1    
+               point_index(k,j+1,i+1) = surfaces%npoints - 1
+            ENDIF
+            IF ( point_index(k,j+1,i) < 0 )  THEN
+               surfaces%npoints     = surfaces%npoints + 1    
+               point_index(k,j+1,i) = surfaces%npoints - 1
+            ENDIF     
+         ENDDO
+!
+!--      Vertical surfaces
+         DO  l = 0, 3
+            DO  m = 1, surf_def_v(l)%ns
+!
+!--            Determine the indices of the respective grid cell inside the
+!--            topography. Please note, j-index for north-facing surfaces 
+!--            ( l==0 ) is identical to the reference j-index outside the grid  
+!--            box. Equivalent for east-facing surfaces and i-index.
+               i = surf_def_v(l)%i(m) + MERGE( surf_def_v(l)%ioff, 0, l == 3 )
+               j = surf_def_v(l)%j(m) + MERGE( surf_def_v(l)%joff, 0, l == 1 )
+               k = surf_def_v(l)%k(m) + surf_def_v(l)%koff
+!
+!--            Lower left /front vertex
+               IF ( point_index(k,j,i) < 0 )  THEN
+                  surfaces%npoints   = surfaces%npoints + 1    
+                  point_index(k,j,i) = surfaces%npoints - 1
+               ENDIF 
+!
+!--            Upper / lower right index for north- and south-facing surfaces
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  IF ( point_index(k,j,i+1) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j,i+1) = surfaces%npoints - 1
+                  ENDIF 
+                  IF ( point_index(k+1,j,i+1) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j,i+1) = surfaces%npoints - 1
+                  ENDIF
+!
+!--            Upper / lower front index for east- and west-facing surfaces
+               ELSEIF ( l == 2  .OR.  l == 3 )  THEN
+                  IF ( point_index(k,j+1,i) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j+1,i) = surfaces%npoints - 1
+                  ENDIF 
+                  IF ( point_index(k+1,j+1,i) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j+1,i) = surfaces%npoints - 1
+                  ENDIF
+               ENDIF
+!
+!--            Upper left / front vertex
+               IF ( point_index(k+1,j,i) < 0 )  THEN
+                  surfaces%npoints     = surfaces%npoints + 1    
+                  point_index(k+1,j,i) = surfaces%npoints - 1
+               ENDIF
+            ENDDO
+            DO  m = 1, surf_lsm_v(l)%ns
+               i = surf_lsm_v(l)%i(m) + MERGE( surf_lsm_v(l)%ioff, 0, l == 3 )
+               j = surf_lsm_v(l)%j(m) + MERGE( surf_lsm_v(l)%joff, 0, l == 1 )
+               k = surf_lsm_v(l)%k(m) + surf_lsm_v(l)%koff
+!
+!--            Lower left /front vertex
+               IF ( point_index(k,j,i) < 0 )  THEN
+                  surfaces%npoints   = surfaces%npoints + 1    
+                  point_index(k,j,i) = surfaces%npoints - 1
+               ENDIF 
+!
+!--            Upper / lower right index for north- and south-facing surfaces
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  IF ( point_index(k,j,i+1) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j,i+1) = surfaces%npoints - 1
+                  ENDIF 
+                  IF ( point_index(k+1,j,i+1) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j,i+1) = surfaces%npoints - 1
+                  ENDIF
+!
+!--            Upper / lower front index for east- and west-facing surfaces
+               ELSEIF ( l == 2  .OR.  l == 3 )  THEN
+                  IF ( point_index(k,j+1,i) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j+1,i) = surfaces%npoints - 1
+                  ENDIF 
+                  IF ( point_index(k+1,j+1,i) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j+1,i) = surfaces%npoints - 1
+                  ENDIF
+               ENDIF
+!
+!--            Upper left / front vertex
+               IF ( point_index(k+1,j,i) < 0 )  THEN
+                  surfaces%npoints     = surfaces%npoints + 1    
+                  point_index(k+1,j,i) = surfaces%npoints - 1
+               ENDIF
+            ENDDO
+
+            DO  m = 1, surf_usm_v(l)%ns
+               i = surf_usm_v(l)%i(m) + MERGE( surf_usm_v(l)%ioff, 0, l == 3 )
+               j = surf_usm_v(l)%j(m) + MERGE( surf_usm_v(l)%joff, 0, l == 1 )
+               k = surf_usm_v(l)%k(m) + surf_usm_v(l)%koff
+!
+!--            Lower left /front vertex
+               IF ( point_index(k,j,i) < 0 )  THEN
+                  surfaces%npoints   = surfaces%npoints + 1    
+                  point_index(k,j,i) = surfaces%npoints - 1
+               ENDIF 
+!
+!--            Upper / lower right index for north- and south-facing surfaces
+               IF ( l == 0  .OR.  l == 1 )  THEN
+                  IF ( point_index(k,j,i+1) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j,i+1) = surfaces%npoints - 1
+                  ENDIF 
+                  IF ( point_index(k+1,j,i+1) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j,i+1) = surfaces%npoints - 1
+                  ENDIF
+!
+!--            Upper / lower front index for east- and west-facing surfaces
+               ELSEIF ( l == 2  .OR.  l == 3 )  THEN
+                  IF ( point_index(k,j+1,i) < 0 )  THEN
+                     surfaces%npoints     = surfaces%npoints + 1    
+                     point_index(k,j+1,i) = surfaces%npoints - 1
+                  ENDIF 
+                  IF ( point_index(k+1,j+1,i) < 0 )  THEN
+                     surfaces%npoints       = surfaces%npoints + 1    
+                     point_index(k+1,j+1,i) = surfaces%npoints - 1
+                  ENDIF
+               ENDIF
+!
+!--            Upper left / front vertex
+               IF ( point_index(k+1,j,i) < 0 )  THEN
+                  surfaces%npoints     = surfaces%npoints + 1    
+                  point_index(k+1,j,i) = surfaces%npoints - 1
+               ENDIF
+            ENDDO
+
+         ENDDO
+!
+!--      Allocate the number of points and polygons. Note, the number of polygons
+!--      is identical to the number of surfaces elements, whereas the number
+!--      of points (vertices), which define the polygons, can be larger.
+         ALLOCATE( surfaces%points(3,1:surfaces%npoints) )
+         ALLOCATE( surfaces%polygons(5,1:surfaces%ns)    )
+!
+!--      Note, PARAVIEW expects consecutively ordered points, in order to
+!--      unambiguously identify surfaces. 
+!--      Hence, all PEs should know where they start counting, depending on the
+!--      number of points on the other PE's with lower MPI rank. 
+#if defined( __parallel )
+         CALL MPI_ALLGATHER( surfaces%npoints, 1, MPI_INTEGER,                 &
+                             num_points_on_pe, 1, MPI_INTEGER, comm2d, ierr  )
+#else
+         num_points_on_pe = surfaces%npoints
+#endif
+
+!
+!--      After the number of vertices is counted, repeat the loops and define the
+!--      vertices. Start with the horizontal default surfaces.
+!--      First, however, determine the offset where couting of points should be
+!--      started, which is the sum of points of all PE's with lower MPI rank.
+         i                 = 0
+         point_index_count = 0
+         DO WHILE ( i < myid  .AND.  i <= SIZE( num_points_on_pe ) )
+            point_index_count = point_index_count + num_points_on_pe(i)
+            i                 = i + 1
+         ENDDO
+          
+         surfaces%npoints = 0
+         point_index      = -1
+         npg              = 0
+      
+         DO  l = 0, 1
+            DO  m = 1, surf_def_h(0)%ns
+!
+!--            Determine the indices of the respective grid cell inside the 
+!--            topography.
+               i = surf_def_h(0)%i(m) + surf_def_h(0)%ioff
+               j = surf_def_h(0)%j(m) + surf_def_h(0)%joff
+               k = surf_def_h(0)%k(m) + surf_def_h(0)%koff
+!
+!--            Check if the vertices that define the surface element are  
+!--            already defined, if not, increment the counter.
+               IF ( point_index(k,j,i) < 0 )  THEN
+                  surfaces%npoints   = surfaces%npoints + 1    
+                  point_index(k,j,i) = point_index_count
+                  point_index_count  = point_index_count + 1               
+                  surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
+                  surfaces%points(3,surfaces%npoints) = zw(k)
+               ENDIF
                IF ( point_index(k,j,i+1) < 0 )  THEN
                   surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j,i+1) = surfaces%npoints - 1
-               ENDIF 
-               IF ( point_index(k+1,j,i+1) < 0 )  THEN
+                  point_index(k,j,i+1) = point_index_count
+                  point_index_count    = point_index_count + 1 
+                  surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                  surfaces%points(3,surfaces%npoints) = zw(k)
+               ENDIF
+               IF ( point_index(k,j+1,i+1) < 0 )  THEN
                   surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j,i+1) = surfaces%npoints - 1
-               ENDIF
-!
-!--         Upper / lower front index for east- and west-facing surfaces
-            ELSEIF ( l == 2  .OR.  l == 3 )  THEN
+                  point_index(k,j+1,i+1) = point_index_count
+                  point_index_count      = point_index_count + 1 
+                  surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                  surfaces%points(3,surfaces%npoints) = zw(k)
+               ENDIF
                IF ( point_index(k,j+1,i) < 0 )  THEN
                   surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j+1,i) = surfaces%npoints - 1
-               ENDIF 
-               IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j+1,i) = surfaces%npoints - 1
-               ENDIF
-            ENDIF
-!
-!--         Upper left / front vertex
-            IF ( point_index(k+1,j,i) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
-               point_index(k+1,j,i) = surfaces%npoints - 1
-            ENDIF
+                  point_index(k,j+1,i) = point_index_count
+                  point_index_count    = point_index_count + 1 
+                  surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                  surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                  surfaces%points(3,surfaces%npoints) = zw(k)
+               ENDIF
+               
+               npg                        = npg + 1
+               surfaces%polygons(1,npg)   = 4
+               surfaces%polygons(2,npg)   = point_index(k,j,i)
+               surfaces%polygons(3,npg)   = point_index(k,j,i+1)
+               surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
+               surfaces%polygons(5,npg)   = point_index(k,j+1,i)
+            ENDDO
          ENDDO
-         DO  m = 1, surf_lsm_v(l)%ns
-            i = surf_lsm_v(l)%i(m) + MERGE( surf_lsm_v(l)%ioff, 0, l == 3 )
-            j = surf_lsm_v(l)%j(m) + MERGE( surf_lsm_v(l)%joff, 0, l == 1 )
-            k = surf_lsm_v(l)%k(m) + surf_lsm_v(l)%koff
-!
-!--         Lower left /front vertex
-            IF ( point_index(k,j,i) < 0 )  THEN
-               surfaces%npoints   = surfaces%npoints + 1    
-               point_index(k,j,i) = surfaces%npoints - 1
-            ENDIF 
-!
-!--         Upper / lower right index for north- and south-facing surfaces
-            IF ( l == 0  .OR.  l == 1 )  THEN
-               IF ( point_index(k,j,i+1) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j,i+1) = surfaces%npoints - 1
-               ENDIF 
-               IF ( point_index(k+1,j,i+1) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j,i+1) = surfaces%npoints - 1
-               ENDIF
-!
-!--         Upper / lower front index for east- and west-facing surfaces
-            ELSEIF ( l == 2  .OR.  l == 3 )  THEN
-               IF ( point_index(k,j+1,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j+1,i) = surfaces%npoints - 1
-               ENDIF 
-               IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j+1,i) = surfaces%npoints - 1
-               ENDIF
-            ENDIF
-!
-!--         Upper left / front vertex
-            IF ( point_index(k+1,j,i) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
-               point_index(k+1,j,i) = surfaces%npoints - 1
-            ENDIF
-         ENDDO
-
-         DO  m = 1, surf_usm_v(l)%ns
-            i = surf_usm_v(l)%i(m) + MERGE( surf_usm_v(l)%ioff, 0, l == 3 )
-            j = surf_usm_v(l)%j(m) + MERGE( surf_usm_v(l)%joff, 0, l == 1 )
-            k = surf_usm_v(l)%k(m) + surf_usm_v(l)%koff
-!
-!--         Lower left /front vertex
-            IF ( point_index(k,j,i) < 0 )  THEN
-               surfaces%npoints   = surfaces%npoints + 1    
-               point_index(k,j,i) = surfaces%npoints - 1
-            ENDIF 
-!
-!--         Upper / lower right index for north- and south-facing surfaces
-            IF ( l == 0  .OR.  l == 1 )  THEN
-               IF ( point_index(k,j,i+1) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j,i+1) = surfaces%npoints - 1
-               ENDIF 
-               IF ( point_index(k+1,j,i+1) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j,i+1) = surfaces%npoints - 1
-               ENDIF
-!
-!--         Upper / lower front index for east- and west-facing surfaces
-            ELSEIF ( l == 2  .OR.  l == 3 )  THEN
-               IF ( point_index(k,j+1,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
-                  point_index(k,j+1,i) = surfaces%npoints - 1
-               ENDIF 
-               IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
-                  point_index(k+1,j+1,i) = surfaces%npoints - 1
-               ENDIF
-            ENDIF
-!
-!--         Upper left / front vertex
-            IF ( point_index(k+1,j,i) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
-               point_index(k+1,j,i) = surfaces%npoints - 1
-            ENDIF
-         ENDDO
-
-      ENDDO
-!
-!--   Allocate the number of points and polygons. Note, the number of polygons
-!--   is identical to the number of surfaces elements, whereas the number
-!--   of points (vertices) which define the polygons can be larger.
-      ALLOCATE( surfaces%points(3,1:surfaces%npoints) )
-      ALLOCATE( surfaces%polygons(5,1:surfaces%ns)    )
-!
-!--   Note, PARAVIEW expects consecutively ordered points which can be
-!--   unambiguously identified. 
-!--   Hence, all PEs know where they should start counting, depending on the
-!--   number of points on the other PE's with lower MPI rank. 
-#if defined( __parallel )
-      CALL MPI_ALLGATHER( surfaces%npoints, 1, MPI_INTEGER,                    &
-                          num_points_on_pe, 1, MPI_INTEGER, comm2d, ierr  )
-#else
-      num_points_on_pe = surfaces%npoints
-#endif
-
-!
-!--   After the number of vertices is counted, repeat the loops and define the
-!--   vertices. Start with the horizontal default surfaces
-!--   First, however, determine the offset where couting of points should be
-!--   started, which is the sum of points of all PE's with lower MPI rank.
-      i                 = 0
-      point_index_count = 0
-      DO WHILE ( i < myid  .AND.  i <= SIZE( num_points_on_pe ) )
-         point_index_count = point_index_count + num_points_on_pe(i)
-         i                 = i + 1
-      ENDDO
-          
-      
-      surfaces%npoints = 0
-      point_index      = -1
-      npg              = 0
-      
-      DO  l = 0, 1
-         DO  m = 1, surf_def_h(0)%ns
-!
-!--         Determine the indices of the respective grid cell inside the topography
-            i = surf_def_h(0)%i(m) + surf_def_h(0)%ioff
-            j = surf_def_h(0)%j(m) + surf_def_h(0)%joff
-            k = surf_def_h(0)%k(m) + surf_def_h(0)%koff
-!
-!--         Check if the vertices that define the surface element are already 
-!--         defined, if not, increment the counter.
+         DO  m = 1, surf_lsm_h%ns
+            i = surf_lsm_h%i(m) + surf_lsm_h%ioff
+            j = surf_lsm_h%j(m) + surf_lsm_h%joff
+            k = surf_lsm_h%k(m) + surf_lsm_h%koff
             IF ( point_index(k,j,i) < 0 )  THEN
                surfaces%npoints   = surfaces%npoints + 1    
                point_index(k,j,i) = point_index_count
-               point_index_count  = point_index_count + 1               
+               point_index_count  = point_index_count + 1 
                surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
                surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
@@ -503,110 +618,12 @@
             surfaces%polygons(3,npg)   = point_index(k,j,i+1)
             surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
-            surfaces%polygons(5,npg)   = point_index(k,j+1,i)
+            surfaces%polygons(5,npg)   = point_index(k,j+1,i) 
          ENDDO
-      ENDDO
-      DO  m = 1, surf_lsm_h%ns
-         i = surf_lsm_h%i(m) + surf_lsm_h%ioff
-         j = surf_lsm_h%j(m) + surf_lsm_h%joff
-         k = surf_lsm_h%k(m) + surf_lsm_h%koff
-         IF ( point_index(k,j,i) < 0 )  THEN
-            surfaces%npoints   = surfaces%npoints + 1    
-            point_index(k,j,i) = point_index_count
-            point_index_count  = point_index_count + 1 
-            surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-            surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-            surfaces%points(3,surfaces%npoints) = zw(k)
-         ENDIF
-         IF ( point_index(k,j,i+1) < 0 )  THEN
-            surfaces%npoints     = surfaces%npoints + 1    
-            point_index(k,j,i+1) = point_index_count
-            point_index_count    = point_index_count + 1 
-            surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-            surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
-            surfaces%points(3,surfaces%npoints) = zw(k)
-         ENDIF
-         IF ( point_index(k,j+1,i+1) < 0 )  THEN
-            surfaces%npoints       = surfaces%npoints + 1    
-            point_index(k,j+1,i+1) = point_index_count
-            point_index_count      = point_index_count + 1 
-            surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-            surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-            surfaces%points(3,surfaces%npoints) = zw(k)
-         ENDIF
-         IF ( point_index(k,j+1,i) < 0 )  THEN
-            surfaces%npoints     = surfaces%npoints + 1    
-            point_index(k,j+1,i) = point_index_count
-            point_index_count    = point_index_count + 1 
-            surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-            surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-            surfaces%points(3,surfaces%npoints) = zw(k)
-         ENDIF
-         
-         npg                        = npg + 1
-         surfaces%polygons(1,npg)   = 4
-         surfaces%polygons(2,npg)   = point_index(k,j,i)
-         surfaces%polygons(3,npg)   = point_index(k,j,i+1)
-         surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
-         surfaces%polygons(5,npg)   = point_index(k,j+1,i) 
-      ENDDO
-
-      DO  m = 1, surf_usm_h%ns
-         i = surf_usm_h%i(m) + surf_usm_h%ioff
-         j = surf_usm_h%j(m) + surf_usm_h%joff
-         k = surf_usm_h%k(m) + surf_usm_h%koff
-
-         IF ( point_index(k,j,i) < 0 )  THEN
-            surfaces%npoints   = surfaces%npoints + 1    
-            point_index(k,j,i) = point_index_count
-            point_index_count  = point_index_count + 1 
-            surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-            surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-            surfaces%points(3,surfaces%npoints) = zw(k)
-         ENDIF
-         IF ( point_index(k,j,i+1) < 0 )  THEN
-            surfaces%npoints     = surfaces%npoints + 1    
-            point_index(k,j,i+1) = point_index_count
-            point_index_count    = point_index_count + 1 
-            surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-            surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
-            surfaces%points(3,surfaces%npoints) = zw(k)
-         ENDIF
-         IF ( point_index(k,j+1,i+1) < 0 )  THEN
-            surfaces%npoints       = surfaces%npoints + 1    
-            point_index(k,j+1,i+1) = point_index_count
-            point_index_count      = point_index_count + 1 
-            surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-            surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-            surfaces%points(3,surfaces%npoints) = zw(k)
-         ENDIF
-         IF ( point_index(k,j+1,i) < 0 )  THEN
-            surfaces%npoints     = surfaces%npoints + 1    
-            point_index(k,j+1,i) = point_index_count
-            point_index_count    = point_index_count + 1 
-            surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-            surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-            surfaces%points(3,surfaces%npoints) = zw(k)
-         ENDIF
-         
-         npg                        = npg + 1
-         surfaces%polygons(1,npg)   = 4
-         surfaces%polygons(2,npg)   = point_index(k,j,i)
-         surfaces%polygons(3,npg)   = point_index(k,j,i+1)
-         surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
-         surfaces%polygons(5,npg)   = point_index(k,j+1,i)    
-      ENDDO
-
-      DO  l = 0, 3
-         DO  m = 1, surf_def_v(l)%ns
-!
-!--         Determine the indices of the respective grid cell inside the topography.
-!--         Please note, j-index for north-facing surfaces ( l==0 ) is 
-!--         identical to the reference j-index outside the grid box. 
-!--         Equivalent for east-facing surfaces and i-index.
-            i = surf_def_v(l)%i(m) + MERGE( surf_def_v(l)%ioff, 0, l == 3 )
-            j = surf_def_v(l)%j(m) + MERGE( surf_def_v(l)%joff, 0, l == 1 )
-            k = surf_def_v(l)%k(m) + surf_def_v(l)%koff
-!
-!--         Lower left /front vertex
+     
+         DO  m = 1, surf_usm_h%ns
+            i = surf_usm_h%i(m) + surf_usm_h%ioff
+            j = surf_usm_h%j(m) + surf_usm_h%joff
+            k = surf_usm_h%k(m) + surf_usm_h%koff
+     
             IF ( point_index(k,j,i) < 0 )  THEN
                surfaces%npoints   = surfaces%npoints + 1    
